Fix the node powered field
[ganeti-local] / Makefile.am
1 # Ganeti makefile
2 # - Indent with tabs only.
3 # - Keep files sorted; one line per file.
4 # - Directories in lib/ must have their own *dir variable (see hypervisor).
5 # - All directories must be listed DIRS.
6 # - Use autogen.sh to generate Makefile.in and configure script.
7
8 # Automake doesn't export these variables before version 1.10.
9 abs_top_builddir = @abs_top_builddir@
10 abs_top_srcdir = @abs_top_srcdir@
11
12 # Helper values for calling builtin functions
13 empty :=
14 space := $(empty) $(empty)
15 comma := ,
16
17 # Use bash in order to be able to use pipefail
18 SHELL=/bin/bash
19
20 ACLOCAL_AMFLAGS = -I autotools
21 BUILD_BASH_COMPLETION = $(top_srcdir)/autotools/build-bash-completion
22 RUN_IN_TEMPDIR = $(top_srcdir)/autotools/run-in-tempdir
23 CHECK_PYTHON_CODE = $(top_srcdir)/autotools/check-python-code
24 CHECK_HEADER = $(top_srcdir)/autotools/check-header
25 CHECK_MAN_DASHES = $(top_srcdir)/autotools/check-man-dashes
26 CHECK_MAN_WARNINGS = $(top_srcdir)/autotools/check-man-warnings
27 CHECK_VERSION = $(top_srcdir)/autotools/check-version
28 CHECK_NEWS = $(top_srcdir)/autotools/check-news
29 CHECK_IMPORTS = $(top_srcdir)/autotools/check-imports
30 DOCPP = $(top_srcdir)/autotools/docpp
31 REPLACE_VARS_SED = autotools/replace_vars.sed
32 CONVERT_CONSTANTS = $(top_srcdir)/autotools/convert-constants
33 BUILD_RPC = $(top_srcdir)/autotools/build-rpc
34 SHELL_ENV_INIT = autotools/shell-env-init
35
36 # Note: these are automake-specific variables, and must be named after
37 # the directory + 'dir' suffix
38 clientdir = $(pkgpythondir)/client
39 hypervisordir = $(pkgpythondir)/hypervisor
40 httpdir = $(pkgpythondir)/http
41 masterddir = $(pkgpythondir)/masterd
42 confddir = $(pkgpythondir)/confd
43 rapidir = $(pkgpythondir)/rapi
44 serverdir = $(pkgpythondir)/server
45 watcherdir = $(pkgpythondir)/watcher
46 impexpddir = $(pkgpythondir)/impexpd
47 utilsdir = $(pkgpythondir)/utils
48 toolsdir = $(pkglibdir)/tools
49 iallocatorsdir = $(pkglibdir)/iallocators
50 pytoolsdir = $(pkgpythondir)/tools
51 docdir = $(datadir)/doc/$(PACKAGE)
52 myexeclibdir = $(pkglibdir)
53
54 # Delete output file if an error occurred while building it
55 .DELETE_ON_ERROR:
56
57 HTOOLS_DIRS = \
58         htools \
59         htools/Ganeti \
60         htools/Ganeti/Confd \
61         htools/Ganeti/HTools \
62         htools/Ganeti/HTools/Program \
63         htools/Ganeti/Query \
64         htest \
65         htest/Test \
66         htest/Test/Ganeti \
67         htest/Test/Ganeti/Confd \
68         htest/Test/Ganeti/HTools \
69         htest/Test/Ganeti/Query
70
71 DIRS = \
72         $(HTOOLS_DIRS) \
73         autotools \
74         daemons \
75         devel \
76         doc \
77         doc/examples \
78         doc/examples/gnt-debug \
79         doc/examples/hooks \
80         htest/data \
81         htest/data/rapi \
82         htest/shelltests \
83         lib \
84         lib/build \
85         lib/client \
86         lib/confd \
87         lib/http \
88         lib/hypervisor \
89         lib/impexpd \
90         lib/masterd \
91         lib/rapi \
92         lib/server \
93         lib/tools \
94         lib/utils \
95         lib/watcher \
96         man \
97         qa \
98         test \
99         test/data \
100         test/data/ovfdata \
101         test/data/ovfdata/other \
102         tools
103
104 BUILDTIME_DIR_AUTOCREATE = \
105         scripts \
106         $(APIDOC_DIR) \
107         $(APIDOC_HS_DIR) \
108         $(APIDOC_HS_DIR)/Ganeti \
109         $(APIDOC_HS_DIR)/Ganeti/Confd \
110         $(APIDOC_HS_DIR)/Ganeti/HTools \
111         $(APIDOC_HS_DIR)/Ganeti/HTools/Program \
112         $(APIDOC_HS_DIR)/Ganeti/Query \
113         $(APIDOC_PY_DIR) \
114         $(COVERAGE_DIR) \
115         $(COVERAGE_HS_DIR) \
116         $(COVERAGE_PY_DIR) \
117         .hpc
118
119 BUILDTIME_DIRS = \
120         $(BUILDTIME_DIR_AUTOCREATE) \
121         doc/html
122
123 DIRCHECK_EXCLUDE = \
124         $(BUILDTIME_DIRS) \
125         ganeti-[0-9]*.[0-9]*.[0-9]* \
126         doc/html/_*
127
128 # some helper vars
129 COVERAGE_DIR = doc/coverage
130 COVERAGE_PY_DIR = $(COVERAGE_DIR)/py
131 COVERAGE_HS_DIR = $(COVERAGE_DIR)/hs
132 APIDOC_DIR = doc/api
133 APIDOC_PY_DIR = $(APIDOC_DIR)/py
134 APIDOC_HS_DIR = $(APIDOC_DIR)/hs
135
136 MAINTAINERCLEANFILES = \
137         $(docpng) \
138         $(maninput) \
139         doc/install-quick.rst \
140         doc/news.rst \
141         doc/upgrade.rst \
142         vcs-version
143
144 maintainer-clean-local:
145         rm -rf $(BUILDTIME_DIRS)
146
147 CLEANFILES = \
148         $(addsuffix /*.py[co],$(DIRS)) \
149         $(addsuffix /*.hi,$(HTOOLS_DIRS)) \
150         $(addsuffix /*.o,$(HTOOLS_DIRS)) \
151         $(PYTHON_BOOTSTRAP) \
152         epydoc.conf \
153         $(REPLACE_VARS_SED) \
154         $(SHELL_ENV_INIT) \
155         daemons/daemon-util \
156         daemons/ganeti-cleaner \
157         devel/upload \
158         $(BUILT_EXAMPLES) \
159         doc/examples/bash_completion \
160         doc/examples/bash_completion-debug \
161         lib/_generated_rpc.py \
162         $(man_MANS) \
163         $(manhtml) \
164         tools/kvm-ifup \
165         tools/vcluster-setup \
166         stamp-directories \
167         stamp-srclinks \
168         $(nodist_pkgpython_PYTHON) \
169         $(HS_ALL_PROGS) $(HS_BUILT_SRCS) \
170         $(HS_BUILT_TEST_HELPERS) \
171         htools/ganeti-confd \
172         .hpc/*.mix htools/*.tix htest/*.tix \
173         doc/hs-lint.html
174
175 GENERATED_FILES = \
176         $(built_base_sources) \
177         $(BUILT_PYTHON_SOURCES) \
178         $(PYTHON_BOOTSTRAP)
179
180 HTOOLS_GENERATED_FILES =
181 if WANT_HTOOLS
182 HTOOLS_GENERATED_FILES += $(HS_PROGS)
183 if ENABLE_CONFD
184 HTOOLS_GENERATED_FILES += htools/hconfd htools/ganeti-confd
185 endif
186 endif
187
188 built_base_sources = \
189         stamp-directories \
190         stamp-srclinks
191
192 built_python_base_sources = \
193         lib/_autoconf.py \
194         lib/_vcsversion.py
195
196 BUILT_PYTHON_SOURCES = \
197         $(built_python_base_sources) \
198         lib/_generated_rpc.py
199
200 # Generating the RPC wrappers depends on many things, so make sure
201 # it's built at the end of the built sources
202 lib/_generated_rpc.py: | $(built_base_sources) $(built_python_base_sources)
203
204 # these are all built from the underlying %.in sources
205 BUILT_EXAMPLES = \
206         doc/examples/ganeti-kvm-poweroff.initd \
207         doc/examples/ganeti.cron \
208         doc/examples/ganeti.initd \
209         doc/examples/gnt-config-backup \
210         doc/examples/hooks/ipsec
211
212 nodist_pkgpython_PYTHON = \
213         $(BUILT_PYTHON_SOURCES)
214
215 noinst_PYTHON = \
216         lib/build/__init__.py \
217         lib/build/shell_example_lexer.py \
218         lib/build/sphinx_ext.py
219
220 pkgpython_PYTHON = \
221         lib/__init__.py \
222         lib/asyncnotifier.py \
223         lib/backend.py \
224         lib/bdev.py \
225         lib/bootstrap.py \
226         lib/cli.py \
227         lib/cmdlib.py \
228         lib/compat.py \
229         lib/config.py \
230         lib/constants.py \
231         lib/daemon.py \
232         lib/errors.py \
233         lib/ht.py \
234         lib/jqueue.py \
235         lib/jstore.py \
236         lib/locking.py \
237         lib/luxi.py \
238         lib/mcpu.py \
239         lib/netutils.py \
240         lib/objects.py \
241         lib/objectutils.py \
242         lib/opcodes.py \
243         lib/ovf.py \
244         lib/pathutils.py \
245         lib/qlang.py \
246         lib/query.py \
247         lib/rpc.py \
248         lib/rpc_defs.py \
249         lib/runtime.py \
250         lib/serializer.py \
251         lib/ssconf.py \
252         lib/ssh.py \
253         lib/storage.py \
254         lib/uidpool.py \
255         lib/vcluster.py \
256         lib/workerpool.py
257
258 client_PYTHON = \
259         lib/client/__init__.py \
260         lib/client/gnt_backup.py \
261         lib/client/gnt_cluster.py \
262         lib/client/gnt_debug.py \
263         lib/client/gnt_group.py \
264         lib/client/gnt_instance.py \
265         lib/client/gnt_job.py \
266         lib/client/gnt_node.py \
267         lib/client/gnt_os.py
268
269 hypervisor_PYTHON = \
270         lib/hypervisor/__init__.py \
271         lib/hypervisor/hv_base.py \
272         lib/hypervisor/hv_chroot.py \
273         lib/hypervisor/hv_fake.py \
274         lib/hypervisor/hv_kvm.py \
275         lib/hypervisor/hv_lxc.py \
276         lib/hypervisor/hv_xen.py
277
278 rapi_PYTHON = \
279         lib/rapi/__init__.py \
280         lib/rapi/baserlib.py \
281         lib/rapi/client.py \
282         lib/rapi/client_utils.py \
283         lib/rapi/connector.py \
284         lib/rapi/rlib2.py \
285         lib/rapi/testutils.py
286
287 http_PYTHON = \
288         lib/http/__init__.py \
289         lib/http/auth.py \
290         lib/http/client.py \
291         lib/http/server.py
292
293 confd_PYTHON = \
294         lib/confd/__init__.py \
295         lib/confd/client.py
296
297 masterd_PYTHON = \
298         lib/masterd/__init__.py \
299         lib/masterd/iallocator.py \
300         lib/masterd/instance.py
301
302 impexpd_PYTHON = \
303         lib/impexpd/__init__.py
304
305 watcher_PYTHON = \
306         lib/watcher/__init__.py \
307         lib/watcher/nodemaint.py \
308         lib/watcher/state.py
309
310 server_PYTHON = \
311         lib/server/__init__.py \
312         lib/server/masterd.py \
313         lib/server/noded.py \
314         lib/server/rapi.py
315
316 pytools_PYTHON = \
317         lib/tools/__init__.py \
318         lib/tools/ensure_dirs.py
319
320 utils_PYTHON = \
321         lib/utils/__init__.py \
322         lib/utils/algo.py \
323         lib/utils/filelock.py \
324         lib/utils/hash.py \
325         lib/utils/io.py \
326         lib/utils/log.py \
327         lib/utils/mlock.py \
328         lib/utils/nodesetup.py \
329         lib/utils/process.py \
330         lib/utils/retry.py \
331         lib/utils/text.py \
332         lib/utils/wrapper.py \
333         lib/utils/x509.py
334
335 docrst = \
336         doc/admin.rst \
337         doc/cluster-merge.rst \
338         doc/design-2.0.rst \
339         doc/design-2.1.rst \
340         doc/design-2.2.rst \
341         doc/design-2.3.rst \
342         doc/design-2.4.rst \
343         doc/design-2.5.rst \
344         doc/design-2.6.rst \
345         doc/design-autorepair.rst \
346         doc/design-bulk-create.rst \
347         doc/design-chained-jobs.rst \
348         doc/design-cpu-pinning.rst \
349         doc/design-draft.rst \
350         doc/design-htools-2.3.rst \
351         doc/design-http-server.rst \
352         doc/design-impexp2.rst \
353         doc/design-lu-generated-jobs.rst \
354         doc/design-multi-reloc.rst \
355         doc/design-network.rst \
356         doc/design-node-state-cache.rst \
357         doc/design-oob.rst \
358         doc/design-ovf-support.rst \
359         doc/design-partitioned.rst \
360         doc/design-query-splitting.rst \
361         doc/design-query2.rst \
362         doc/design-resource-model.rst \
363         doc/design-shared-storage.rst \
364         doc/design-virtual-clusters.rst \
365         doc/design-x509-ca.rst \
366         doc/devnotes.rst \
367         doc/glossary.rst \
368         doc/hooks.rst \
369         doc/iallocator.rst \
370         doc/index.rst \
371         doc/install-quick.rst \
372         doc/install.rst \
373         doc/locking.rst \
374         doc/move-instance.rst \
375         doc/news.rst \
376         doc/ovfconverter.rst \
377         doc/rapi.rst \
378         doc/security.rst \
379         doc/upgrade.rst \
380         doc/virtual-cluster.rst \
381         doc/walkthrough.rst
382
383 HS_PROGS = htools/htools
384 HS_BIN_ROLES = hbal hscan hspace hinfo hcheck
385 HS_HTOOLS_PROGS = $(HS_BIN_ROLES) hail
386
387 HS_ALL_PROGS = $(HS_PROGS) htest/test htest/hpc-htools htools/hconfd
388 HS_PROG_SRCS = $(patsubst %,%.hs,$(HS_ALL_PROGS))
389 HS_BUILT_TEST_HELPERS = $(HS_BIN_ROLES:%=htest/%) htest/hail
390
391 HFLAGS = -O -Wall -Werror -fwarn-monomorphism-restriction -fwarn-tabs -ihtools
392 # extra flags that can be overriden on the command line (e.g. -Wwarn, etc.)
393 HEXTRA =
394 # internal extra flags (used for htest/test mainly)
395 HEXTRA_INT =
396 # exclude options for coverage reports
397 HPCEXCL = --exclude Main \
398         --exclude Ganeti.Constants \
399         --exclude Ganeti.HTools.QC \
400         --exclude Ganeti.THH \
401         --exclude Ganeti.Version \
402         --exclude Test.Ganeti.TestCommon \
403         --exclude Test.Ganeti.TestHTools \
404         --exclude Test.Ganeti.TestHelper \
405         --exclude Test.Ganeti.TestImports \
406         $(patsubst htools.%,--exclude Test.%,$(subst /,.,$(patsubst %.hs,%, $(HS_LIB_SRCS))))
407
408 HS_LIB_SRCS = \
409         htools/Ganeti/BasicTypes.hs \
410         htools/Ganeti/Common.hs \
411         htools/Ganeti/Compat.hs \
412         htools/Ganeti/Confd.hs \
413         htools/Ganeti/Confd/Server.hs \
414         htools/Ganeti/Confd/Utils.hs \
415         htools/Ganeti/Config.hs \
416         htools/Ganeti/Daemon.hs \
417         htools/Ganeti/HTools/CLI.hs \
418         htools/Ganeti/HTools/Cluster.hs \
419         htools/Ganeti/HTools/Container.hs \
420         htools/Ganeti/HTools/ExtLoader.hs \
421         htools/Ganeti/HTools/Group.hs \
422         htools/Ganeti/HTools/IAlloc.hs \
423         htools/Ganeti/HTools/Instance.hs \
424         htools/Ganeti/HTools/Loader.hs \
425         htools/Ganeti/HTools/Luxi.hs \
426         htools/Ganeti/HTools/Node.hs \
427         htools/Ganeti/HTools/PeerMap.hs \
428         htools/Ganeti/HTools/Program.hs \
429         htools/Ganeti/HTools/Program/Hail.hs \
430         htools/Ganeti/HTools/Program/Hbal.hs \
431         htools/Ganeti/HTools/Program/Hcheck.hs \
432         htools/Ganeti/HTools/Program/Hinfo.hs \
433         htools/Ganeti/HTools/Program/Hscan.hs \
434         htools/Ganeti/HTools/Program/Hspace.hs \
435         htools/Ganeti/HTools/Rapi.hs \
436         htools/Ganeti/HTools/Simu.hs \
437         htools/Ganeti/HTools/Text.hs \
438         htools/Ganeti/HTools/Types.hs \
439         htools/Ganeti/Hash.hs \
440         htools/Ganeti/JSON.hs \
441         htools/Ganeti/Jobs.hs \
442         htools/Ganeti/Logging.hs \
443         htools/Ganeti/Luxi.hs \
444         htools/Ganeti/Objects.hs \
445         htools/Ganeti/OpCodes.hs \
446         htools/Ganeti/Path.hs \
447         htools/Ganeti/Query/Common.hs \
448         htools/Ganeti/Query/Filter.hs \
449         htools/Ganeti/Query/Group.hs \
450         htools/Ganeti/Query/Language.hs \
451         htools/Ganeti/Query/Node.hs \
452         htools/Ganeti/Query/Query.hs \
453         htools/Ganeti/Query/Server.hs \
454         htools/Ganeti/Query/Types.hs \
455         htools/Ganeti/Rpc.hs \
456         htools/Ganeti/Runtime.hs \
457         htools/Ganeti/Ssconf.hs \
458         htools/Ganeti/THH.hs \
459         htools/Ganeti/Utils.hs
460
461 HS_TEST_SRCS = \
462         htest/Test/Ganeti/BasicTypes.hs \
463         htest/Test/Ganeti/Common.hs \
464         htest/Test/Ganeti/Confd/Utils.hs \
465         htest/Test/Ganeti/Daemon.hs \
466         htest/Test/Ganeti/HTools/CLI.hs \
467         htest/Test/Ganeti/HTools/Cluster.hs \
468         htest/Test/Ganeti/HTools/Container.hs \
469         htest/Test/Ganeti/HTools/Instance.hs \
470         htest/Test/Ganeti/HTools/Loader.hs \
471         htest/Test/Ganeti/HTools/Node.hs \
472         htest/Test/Ganeti/HTools/PeerMap.hs \
473         htest/Test/Ganeti/HTools/Simu.hs \
474         htest/Test/Ganeti/HTools/Text.hs \
475         htest/Test/Ganeti/HTools/Types.hs \
476         htest/Test/Ganeti/JSON.hs \
477         htest/Test/Ganeti/Jobs.hs \
478         htest/Test/Ganeti/Luxi.hs \
479         htest/Test/Ganeti/Objects.hs \
480         htest/Test/Ganeti/OpCodes.hs \
481         htest/Test/Ganeti/Query/Filter.hs \
482         htest/Test/Ganeti/Query/Language.hs \
483         htest/Test/Ganeti/Query/Query.hs \
484         htest/Test/Ganeti/Rpc.hs \
485         htest/Test/Ganeti/Ssconf.hs \
486         htest/Test/Ganeti/TestCommon.hs \
487         htest/Test/Ganeti/TestHTools.hs \
488         htest/Test/Ganeti/TestHelper.hs \
489         htest/Test/Ganeti/Utils.hs
490
491 HS_LIBTEST_SRCS = $(HS_LIB_SRCS) $(HS_TEST_SRCS)
492
493 HS_BUILT_SRCS = \
494         htest/Test/Ganeti/TestImports.hs \
495         htools/Ganeti/Constants.hs \
496         htools/Ganeti/Version.hs
497 HS_BUILT_SRCS_IN = $(patsubst %,%.in,$(HS_BUILT_SRCS))
498
499 $(RUN_IN_TEMPDIR): | stamp-directories
500
501 # Note: we use here an order-only prerequisite, as the contents of
502 # _autoconf.py are not actually influencing the html build output: it
503 # has to exist in order for the sphinx module to be loaded
504 # successfully, but we certainly don't want the docs to be rebuilt if
505 # it changes
506 doc/html/index.html: $(docrst) $(docpng) doc/conf.py configure.ac \
507         $(RUN_IN_TEMPDIR) lib/build/sphinx_ext.py \
508         lib/build/shell_example_lexer.py lib/opcodes.py lib/ht.py \
509         | $(BUILT_PYTHON_SOURCES)
510         @test -n "$(SPHINX)" || \
511             { echo 'sphinx-build' not found during configure; exit 1; }
512         @mkdir_p@ $(dir $@)
513         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(SPHINX) -q -W -b html \
514             -d . \
515             -D version="$(VERSION_MAJOR).$(VERSION_MINOR)" \
516             -D release="$(PACKAGE_VERSION)" \
517             $(abs_top_srcdir)/doc $(CURDIR)/doc/html
518         rm -f doc/html/.buildinfo doc/html/objects.inv
519         touch $@
520
521 doc/html: doc/html/index.html
522
523 doc/install-quick.rst: INSTALL
524 doc/news.rst: NEWS
525 doc/upgrade.rst: UPGRADE
526
527 doc/install-quick.rst doc/news.rst doc/upgrade.rst:
528         set -e; \
529         { echo '.. This file is automatically updated at build time from $<.'; \
530           echo '.. Do not edit.'; \
531           echo; \
532           cat $<; \
533         } > $@
534
535 docdot = \
536         doc/arch-2.0.dot \
537         doc/design-2.1-lock-acquire.dot \
538         doc/design-2.1-lock-release.dot
539
540 docpng = $(patsubst %.dot,%.png,$(docdot))
541
542 # Things to build but not to install (add it to EXTRA_DIST if it should be
543 # distributed)
544 noinst_DATA = \
545         devel/upload \
546         doc/html \
547         $(BUILT_EXAMPLES) \
548         doc/examples/bash_completion \
549         doc/examples/bash_completion-debug \
550         $(manhtml)
551
552 gnt_scripts = \
553         scripts/gnt-backup \
554         scripts/gnt-cluster \
555         scripts/gnt-debug \
556         scripts/gnt-group \
557         scripts/gnt-instance \
558         scripts/gnt-job \
559         scripts/gnt-node \
560         scripts/gnt-os
561
562 PYTHON_BOOTSTRAP_SBIN = \
563         daemons/ganeti-masterd \
564         daemons/ganeti-noded \
565         daemons/ganeti-rapi \
566         daemons/ganeti-watcher \
567         $(gnt_scripts)
568
569 PYTHON_BOOTSTRAP = \
570         $(PYTHON_BOOTSTRAP_SBIN) \
571         tools/ensure-dirs
572
573 qa_scripts = \
574         qa/__init__.py \
575         qa/ganeti-qa.py \
576         qa/qa_cluster.py \
577         qa/qa_config.py \
578         qa/qa_daemon.py \
579         qa/qa_env.py \
580         qa/qa_error.py \
581         qa/qa_group.py \
582         qa/qa_instance.py \
583         qa/qa_job.py \
584         qa/qa_node.py \
585         qa/qa_os.py \
586         qa/qa_rapi.py \
587         qa/qa_tags.py \
588         qa/qa_utils.py
589
590 bin_SCRIPTS =
591 if WANT_HTOOLS
592 bin_SCRIPTS += $(filter-out htools/hail,$(HS_PROGS))
593 install-exec-hook:
594         @mkdir_p@ $(DESTDIR)$(iallocatorsdir)
595 # FIXME: this is a hardcoded logic, instead of auto-resolving
596         $(LN_S) -f ../../../bin/htools \
597                    $(DESTDIR)$(iallocatorsdir)/hail
598         for role in $(HS_BIN_ROLES); do \
599                 $(LN_S) -f htools \
600                            $(DESTDIR)$(bindir)/$$role ; \
601         done
602 endif
603
604 $(HS_ALL_PROGS): %: %.hs $(HS_LIBTEST_SRCS) $(HS_BUILT_SRCS) Makefile
605         @if [ "$(notdir $@)" = "test" ] && [ "$(HTOOLS_NODEV)" ]; then \
606           echo "Error: cannot run unittests without the development" \
607                " libraries (see devnotes.rst)" 1>&2; \
608           exit 1; \
609         fi
610         @rm -f $(notdir $@).tix
611         $(GHC) --make \
612           $(HFLAGS) \
613           $(HTOOLS_NOCURL) $(HTOOLS_PARALLEL3) $(HTOOLS_REGEX_PCRE) \
614           -osuf $(notdir $@).o -hisuf $(notdir $@).hi \
615           $(HEXTRA) $(HEXTRA_INT) $@
616         @touch "$@"
617
618 # for the htest/test binary, we need to enable profiling/coverage
619 htest/test: HEXTRA_INT=-fhpc -ihtest
620
621 # we compile the hpc-htools binary with the program coverage
622 htest/hpc-htools: HEXTRA_INT=-fhpc
623
624 # test dependency
625 htest/offline-tests.sh: htest/hpc-htools
626
627 # rules for building profiling-enabled versions of the haskell
628 # programs: hs-prof does the full two-step build, whereas
629 # hs-prof-quick does only the final rebuild (hs-prof must have been
630 # run before)
631 .PHONY: hs-prof hs-prof-quick
632 hs-prof:
633         $(MAKE) $(AM_MAKEFLAGS) clean
634         $(MAKE) $(AM_MAKEFLAGS) $(HS_ALL_PROGS) HEXTRA="-osuf .o"
635         rm -f $(HS_ALL_PROGS)
636         $(MAKE) $(AM_MAKEFLAGS) hs-prof-quick
637
638 hs-prof-quick:
639         $(MAKE) $(AM_MAKEFLAGS) $(HS_ALL_PROGS) HEXTRA="-osuf .prof_o -prof -auto-all"
640
641 dist_sbin_SCRIPTS = \
642         tools/ganeti-listrunner
643
644 nodist_sbin_SCRIPTS = \
645         $(PYTHON_BOOTSTRAP_SBIN) \
646         daemons/ganeti-cleaner
647
648 if ENABLE_CONFD
649 htools/ganeti-confd: htools/hconfd
650         cp -f $< $@
651
652 nodist_sbin_SCRIPTS += htools/ganeti-confd
653 endif
654
655 python_scripts = \
656         tools/burnin \
657         tools/cfgshell \
658         tools/cfgupgrade \
659         tools/cfgupgrade12 \
660         tools/cluster-merge \
661         tools/confd-client \
662         tools/fmtjson \
663         tools/lvmstrap \
664         tools/move-instance \
665         tools/ovfconverter \
666         tools/sanitize-config \
667         tools/setup-ssh
668
669 dist_tools_SCRIPTS = \
670         $(python_scripts) \
671         tools/kvm-console-wrapper \
672         tools/master-ip-setup \
673         tools/xm-console-wrapper
674
675 nodist_tools_SCRIPTS = \
676         tools/vcluster-setup
677
678 pkglib_python_scripts = \
679         daemons/import-export \
680         tools/check-cert-expired
681
682 nodist_pkglib_python_scripts = \
683         tools/ensure-dirs
684
685 myexeclib_SCRIPTS = \
686         daemons/daemon-util \
687         tools/kvm-ifup \
688         $(pkglib_python_scripts)
689
690 nodist_myexeclib_SCRIPTS = \
691         $(nodist_pkglib_python_scripts)
692
693 EXTRA_DIST = \
694         NEWS \
695         UPGRADE \
696         epydoc.conf.in \
697         pylintrc \
698         autotools/build-bash-completion \
699         autotools/build-rpc \
700         autotools/check-header \
701         autotools/check-imports \
702         autotools/check-man-dashes \
703         autotools/check-man-warnings \
704         autotools/check-news \
705         autotools/check-python-code \
706         autotools/check-tar \
707         autotools/check-version \
708         autotools/convert-constants \
709         autotools/docpp \
710         autotools/gen-coverage \
711         autotools/testrunner \
712         autotools/wrong-hardcoded-paths \
713         $(RUN_IN_TEMPDIR) \
714         daemons/daemon-util.in \
715         daemons/ganeti-cleaner.in \
716         $(pkglib_python_scripts) \
717         devel/upload.in \
718         tools/kvm-ifup.in \
719         tools/vcluster-setup.in \
720         $(docdot) \
721         $(docpng) \
722         $(docrst) \
723         doc/conf.py \
724         doc/html \
725         $(BUILT_EXAMPLES:%=%.in) \
726         doc/examples/ganeti.default \
727         doc/examples/ganeti.default-debug \
728         doc/examples/hooks/ethers \
729         doc/examples/gnt-debug/README \
730         doc/examples/gnt-debug/delay0.json \
731         doc/examples/gnt-debug/delay50.json \
732         test/lockperf.py \
733         test/testutils.py \
734         test/mocks.py \
735         $(dist_TESTS) \
736         $(TEST_FILES) \
737         man/footer.rst \
738         $(manrst) \
739         $(maninput) \
740         qa/qa-sample.json \
741         $(qa_scripts) \
742         $(HS_LIBTEST_SRCS) $(HS_BUILT_SRCS_IN) \
743         $(HS_PROG_SRCS) \
744         htools/lint-hints.hs \
745         htest/cli-tests-defs.sh \
746         htest/offline-test.sh
747
748 man_MANS = \
749         man/ganeti-cleaner.8 \
750         man/ganeti-confd.8 \
751         man/ganeti-listrunner.8 \
752         man/ganeti-masterd.8 \
753         man/ganeti-noded.8 \
754         man/ganeti-os-interface.7 \
755         man/ganeti-rapi.8 \
756         man/ganeti-watcher.8 \
757         man/ganeti.7 \
758         man/gnt-backup.8 \
759         man/gnt-cluster.8 \
760         man/gnt-debug.8 \
761         man/gnt-group.8 \
762         man/gnt-instance.8 \
763         man/gnt-job.8 \
764         man/gnt-node.8 \
765         man/gnt-os.8 \
766         man/hail.1 \
767         man/hbal.1 \
768         man/hcheck.1 \
769         man/hinfo.1 \
770         man/hscan.1 \
771         man/hspace.1 \
772         man/htools.1
773
774 manrst = $(patsubst %.1,%.rst,$(patsubst %.7,%.rst,$(patsubst %.8,%.rst,$(man_MANS))))
775 manhtml = $(patsubst %.rst,%.html,$(manrst))
776 mangen = $(patsubst %.rst,%.gen,$(manrst))
777 maninput = \
778         $(patsubst %.1,%.1.in,$(patsubst %.7,%.7.in,$(patsubst %.8,%.8.in,$(man_MANS)))) \
779         $(patsubst %.html,%.html.in,$(manhtml)) \
780         man/footer.man man/footer.html $(mangen)
781
782 TEST_FILES = \
783         htest/data/common-suffix.data \
784         htest/data/hail-alloc-drbd.json \
785         htest/data/hail-change-group.json \
786         htest/data/hail-invalid-reloc.json \
787         htest/data/hail-node-evac.json \
788         htest/data/hail-reloc-drbd.json \
789         htest/data/hbal-split-insts.data \
790         htest/data/invalid-node.data \
791         htest/data/missing-resources.data \
792         htest/data/rapi/groups.json \
793         htest/data/rapi/info.json \
794         htest/data/rapi/instances.json \
795         htest/data/rapi/nodes.json \
796         htest/shelltests/htools-balancing.test \
797         htest/shelltests/htools-basic.test \
798         htest/shelltests/htools-dynutil.test \
799         htest/shelltests/htools-excl.test \
800         htest/shelltests/htools-hail.test \
801         htest/shelltests/htools-hspace.test \
802         htest/shelltests/htools-invalid.test \
803         htest/shelltests/htools-multi-group.test \
804         htest/shelltests/htools-no-backend.test \
805         htest/shelltests/htools-rapi.test \
806         htest/shelltests/htools-single-group.test \
807         htest/shelltests/htools-text-backend.test \
808         test/data/bdev-drbd-8.0.txt \
809         test/data/bdev-drbd-8.3.txt \
810         test/data/bdev-drbd-disk.txt \
811         test/data/bdev-drbd-net-ip4.txt \
812         test/data/bdev-drbd-net-ip6.txt \
813         test/data/cert1.pem \
814         test/data/ip-addr-show-dummy0.txt \
815         test/data/ip-addr-show-lo-ipv4.txt \
816         test/data/ip-addr-show-lo-ipv6.txt \
817         test/data/ip-addr-show-lo-oneline-ipv4.txt \
818         test/data/ip-addr-show-lo-oneline-ipv6.txt \
819         test/data/ip-addr-show-lo-oneline.txt \
820         test/data/ip-addr-show-lo.txt \
821         test/data/kvm_0.12.5_help.txt \
822         test/data/kvm_0.15.90_help.txt \
823         test/data/kvm_0.9.1_help.txt \
824         test/data/kvm_1.0_help.txt \
825         test/data/ovfdata/compr_disk.vmdk.gz \
826         test/data/ovfdata/config.ini \
827         test/data/ovfdata/corrupted_resources.ovf \
828         test/data/ovfdata/empty.ini \
829         test/data/ovfdata/empty.ovf \
830         test/data/ovfdata/ganeti.mf \
831         test/data/ovfdata/ganeti.ovf \
832         test/data/ovfdata/gzip_disk.ovf \
833         test/data/ovfdata/new_disk.vmdk \
834         test/data/ovfdata/no_disk.ini \
835         test/data/ovfdata/no_disk_in_ref.ovf \
836         test/data/ovfdata/no_os.ini \
837         test/data/ovfdata/no_ovf.ova \
838         test/data/ovfdata/other/rawdisk.raw \
839         test/data/ovfdata/ova.ova \
840         test/data/ovfdata/rawdisk.raw \
841         test/data/ovfdata/second_disk.vmdk \
842         test/data/ovfdata/unsafe_path.ini \
843         test/data/ovfdata/virtualbox.ovf \
844         test/data/ovfdata/wrong_config.ini \
845         test/data/ovfdata/wrong_extension.ovd \
846         test/data/ovfdata/wrong_manifest.mf \
847         test/data/ovfdata/wrong_manifest.ovf \
848         test/data/ovfdata/wrong_ova.ova \
849         test/data/ovfdata/wrong_xml.ovf \
850         test/data/proc_drbd8.txt \
851         test/data/proc_drbd80-emptyline.txt \
852         test/data/proc_drbd83.txt \
853         test/data/proc_drbd83_sync.txt \
854         test/data/proc_drbd83_sync_krnl2.6.39.txt \
855         test/data/sys_drbd_usermode_helper.txt \
856         test/data/vgreduce-removemissing-2.02.02.txt \
857         test/data/vgreduce-removemissing-2.02.66-fail.txt \
858         test/data/vgreduce-removemissing-2.02.66-ok.txt \
859         test/data/vgs-missing-pvs-2.02.02.txt \
860         test/data/vgs-missing-pvs-2.02.66.txt \
861         test/ganeti-cli.test \
862         test/gnt-cli.test \
863         test/import-export_unittest-helper
864
865 python_tests = \
866         doc/examples/rapi_testutils.py \
867         test/cfgupgrade_unittest.py \
868         test/docs_unittest.py \
869         test/ganeti.asyncnotifier_unittest.py \
870         test/ganeti.backend_unittest.py \
871         test/ganeti.bdev_unittest.py \
872         test/ganeti.cli_unittest.py \
873         test/ganeti.client.gnt_cluster_unittest.py \
874         test/ganeti.client.gnt_instance_unittest.py \
875         test/ganeti.cmdlib_unittest.py \
876         test/ganeti.compat_unittest.py \
877         test/ganeti.confd.client_unittest.py \
878         test/ganeti.config_unittest.py \
879         test/ganeti.constants_unittest.py \
880         test/ganeti.daemon_unittest.py \
881         test/ganeti.errors_unittest.py \
882         test/ganeti.hooks_unittest.py \
883         test/ganeti.ht_unittest.py \
884         test/ganeti.http_unittest.py \
885         test/ganeti.hypervisor.hv_chroot_unittest.py \
886         test/ganeti.hypervisor.hv_fake_unittest.py \
887         test/ganeti.hypervisor.hv_kvm_unittest.py \
888         test/ganeti.hypervisor.hv_lxc_unittest.py \
889         test/ganeti.hypervisor.hv_xen_unittest.py \
890         test/ganeti.hypervisor_unittest.py \
891         test/ganeti.impexpd_unittest.py \
892         test/ganeti.jqueue_unittest.py \
893         test/ganeti.jstore_unittest.py \
894         test/ganeti.locking_unittest.py \
895         test/ganeti.luxi_unittest.py \
896         test/ganeti.masterd.iallocator_unittest.py \
897         test/ganeti.masterd.instance_unittest.py \
898         test/ganeti.mcpu_unittest.py \
899         test/ganeti.netutils_unittest.py \
900         test/ganeti.objects_unittest.py \
901         test/ganeti.objectutils_unittest.py \
902         test/ganeti.opcodes_unittest.py \
903         test/ganeti.ovf_unittest.py \
904         test/ganeti.qlang_unittest.py \
905         test/ganeti.query_unittest.py \
906         test/ganeti.rapi.baserlib_unittest.py \
907         test/ganeti.rapi.client_unittest.py \
908         test/ganeti.rapi.resources_unittest.py \
909         test/ganeti.rapi.rlib2_unittest.py \
910         test/ganeti.rapi.testutils_unittest.py \
911         test/ganeti.rpc_unittest.py \
912         test/ganeti.runtime_unittest.py \
913         test/ganeti.serializer_unittest.py \
914         test/ganeti.ssh_unittest.py \
915         test/ganeti.storage_unittest.py \
916         test/ganeti.tools.ensure_dirs_unittest.py \
917         test/ganeti.uidpool_unittest.py \
918         test/ganeti.utils.algo_unittest.py \
919         test/ganeti.utils.filelock_unittest.py \
920         test/ganeti.utils.hash_unittest.py \
921         test/ganeti.utils.io_unittest-runasroot.py \
922         test/ganeti.utils.io_unittest.py \
923         test/ganeti.utils.log_unittest.py \
924         test/ganeti.utils.mlock_unittest.py \
925         test/ganeti.utils.nodesetup_unittest.py \
926         test/ganeti.utils.process_unittest.py \
927         test/ganeti.utils.retry_unittest.py \
928         test/ganeti.utils.text_unittest.py \
929         test/ganeti.utils.wrapper_unittest.py \
930         test/ganeti.utils.x509_unittest.py \
931         test/ganeti.utils_unittest.py \
932         test/ganeti.vcluster_unittest.py \
933         test/ganeti.workerpool_unittest.py \
934         test/pycurl_reset_unittest.py \
935         test/qa.qa_config_unittest.py \
936         test/tempfile_fork_unittest.py
937
938 haskell_tests = htest/test
939
940 dist_TESTS = \
941         test/check-cert-expired_unittest.bash \
942         test/daemon-util_unittest.bash \
943         test/ganeti-cleaner_unittest.bash \
944         test/import-export_unittest.bash \
945         test/cli-test.bash \
946         test/bash_completion.bash \
947         $(python_tests)
948
949 nodist_TESTS =
950 check_SCRIPTS =
951
952 if WANT_HTOOLSTESTS
953 nodist_TESTS += $(haskell_tests)
954 dist_TESTS += htest/offline-test.sh
955 check_SCRIPTS += htest/hpc-htools $(HS_BUILT_TEST_HELPERS)
956 endif
957
958 TESTS = $(dist_TESTS) $(nodist_TESTS)
959
960 # Environment for all tests
961 PLAIN_TESTS_ENVIRONMENT = \
962         PYTHONPATH=. \
963         TOP_SRCDIR=$(abs_top_srcdir) TOP_BUILDDIR=$(abs_top_builddir) \
964         PYTHON=$(PYTHON) FAKEROOT=$(FAKEROOT_PATH) \
965         $(RUN_IN_TEMPDIR)
966
967 # Environment for tests run by automake
968 TESTS_ENVIRONMENT = \
969         $(PLAIN_TESTS_ENVIRONMENT) $(abs_top_srcdir)/autotools/testrunner
970
971 all_python_code = \
972         $(dist_sbin_SCRIPTS) \
973         $(python_scripts) \
974         $(pkglib_python_scripts) \
975         $(nodist_pkglib_python_scripts) \
976         $(python_tests) \
977         $(pkgpython_PYTHON) \
978         $(client_PYTHON) \
979         $(hypervisor_PYTHON) \
980         $(rapi_PYTHON) \
981         $(server_PYTHON) \
982         $(pytools_PYTHON) \
983         $(http_PYTHON) \
984         $(confd_PYTHON) \
985         $(masterd_PYTHON) \
986         $(impexpd_PYTHON) \
987         $(utils_PYTHON) \
988         $(watcher_PYTHON) \
989         $(noinst_PYTHON) \
990         $(qa_scripts)
991
992 srclink_files = \
993         man/footer.rst \
994         test/check-cert-expired_unittest.bash \
995         test/daemon-util_unittest.bash \
996         test/ganeti-cleaner_unittest.bash \
997         test/import-export_unittest.bash \
998         test/cli-test.bash \
999         test/bash_completion.bash \
1000         htest/offline-test.sh \
1001         htest/cli-tests-defs.sh \
1002         $(all_python_code) \
1003         $(HS_LIBTEST_SRCS) $(HS_PROG_SRCS)
1004
1005 check_python_code = \
1006         $(BUILD_BASH_COMPLETION) \
1007         $(CHECK_IMPORTS) \
1008         $(CHECK_HEADER) \
1009         $(DOCPP) \
1010         $(all_python_code)
1011
1012 lint_python_code = \
1013         ganeti \
1014         ganeti/http/server.py \
1015         $(dist_sbin_SCRIPTS) \
1016         $(python_scripts) \
1017         $(pkglib_python_scripts) \
1018         $(BUILD_BASH_COMPLETION) \
1019         $(CHECK_IMPORTS) \
1020         $(CHECK_HEADER) \
1021         $(DOCPP) \
1022         $(PYTHON_BOOTSTRAP)
1023
1024 standalone_python_modules = \
1025         lib/rapi/client.py \
1026         tools/ganeti-listrunner
1027
1028 pep8_python_code = \
1029         ganeti \
1030         ganeti/http/server.py \
1031         $(dist_sbin_SCRIPTS) \
1032         $(python_scripts) \
1033         $(pkglib_python_scripts) \
1034         $(BUILD_BASH_COMPLETION) \
1035         $(CHECK_HEADER) \
1036         $(DOCPP) \
1037         $(PYTHON_BOOTSTRAP) \
1038         qa
1039
1040 test/daemon-util_unittest.bash: daemons/daemon-util
1041
1042 test/ganeti-cleaner_unittest.bash: daemons/ganeti-cleaner
1043
1044 test/bash_completion.bash: doc/examples/bash_completion-debug
1045
1046 tools/kvm-ifup: tools/kvm-ifup.in $(REPLACE_VARS_SED)
1047         sed -f $(REPLACE_VARS_SED) < $< > $@
1048         chmod +x $@
1049
1050 devel/upload: devel/upload.in $(REPLACE_VARS_SED)
1051         sed -f $(REPLACE_VARS_SED) < $< > $@
1052         chmod u+x $@
1053
1054 tools/vcluster-setup: tools/vcluster-setup.in $(REPLACE_VARS_SED)
1055         sed -f $(REPLACE_VARS_SED) < $< > $@
1056         chmod +x $@
1057
1058 daemons/%:: daemons/%.in $(REPLACE_VARS_SED)
1059         sed -f $(REPLACE_VARS_SED) < $< > $@
1060         chmod +x $@
1061
1062 doc/examples/%:: doc/examples/%.in $(REPLACE_VARS_SED)
1063         sed -f $(REPLACE_VARS_SED) < $< > $@
1064
1065 doc/examples/bash_completion: BC_ARGS = --compact
1066 doc/examples/bash_completion-debug: BC_ARGS =
1067
1068 doc/examples/bash_completion doc/examples/bash_completion-debug: \
1069         $(BUILD_BASH_COMPLETION) $(RUN_IN_TEMPDIR) \
1070         lib/cli.py $(gnt_scripts) $(client_PYTHON) tools/burnin \
1071         daemons/ganeti-cleaner \
1072         $(GENERATED_FILES) $(HTOOLS_GENERATED_FILES)
1073         PYTHONPATH=. $(RUN_IN_TEMPDIR) \
1074           $(CURDIR)/$(BUILD_BASH_COMPLETION) $(BC_ARGS) > $@
1075
1076 doc/%.png: doc/%.dot
1077         @test -n "$(DOT)" || { echo 'dot' not found during configure; exit 1; }
1078         $(DOT) -Tpng -o $@ $<
1079
1080 man/footer.man: man/footer.rst
1081         @test -n "$(PANDOC)" || \
1082           { echo 'pandoc' not found during configure; exit 1; }
1083         $(PANDOC) -f rst -t man -o $@ $<
1084
1085 man/footer.html: man/footer.rst
1086         @test -n "$(PANDOC)" || \
1087           { echo 'pandoc' not found during configure; exit 1; }
1088         $(PANDOC) -f rst -t html -o $@ $<
1089
1090 man/%.gen: man/%.rst lib/query.py lib/build/sphinx_ext.py \
1091         lib/build/shell_example_lexer.py \
1092         | $(RUN_IN_TEMPDIR) $(BUILT_PYTHON_SOURCES)
1093         @echo "Checking $< for hardcoded paths..."
1094         @if grep -nEf autotools/wrong-hardcoded-paths $<; then \
1095           echo "Man page $< has harcoded paths (see above)!" 1>&2 ; \
1096           exit 1; \
1097         fi
1098         set -e ; \
1099         trap 'echo auto-removing $@; rm $@' EXIT; \
1100         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(DOCPP) < $< > $@ ;\
1101         trap - EXIT
1102
1103 man/%.7.in man/%.8.in man/%.1.in: man/%.gen man/footer.man
1104         @test -n "$(PANDOC)" || \
1105           { echo 'pandoc' not found during configure; exit 1; }
1106         set -o pipefail ; \
1107         trap 'echo auto-removing $@; rm $@' EXIT; \
1108         $(PANDOC) -s -f rst -t man -A man/footer.man $< | \
1109           sed -e 's/\\@/@/g' > $@; \
1110         if test -n "$(MAN_HAS_WARNINGS)"; then $(CHECK_MAN_WARNINGS) $@; fi; \
1111         $(CHECK_MAN_DASHES) $@; \
1112         trap - EXIT
1113
1114
1115 man/%.html.in: man/%.gen man/footer.html
1116         @test -n "$(PANDOC)" || \
1117           { echo 'pandoc' not found during configure; exit 1; }
1118         set -o pipefail ; \
1119         $(PANDOC) -s -f rst -t html -A man/footer.html $< | \
1120           sed -e 's/\\@/@/g' > $@
1121
1122 man/%: man/%.in  $(REPLACE_VARS_SED)
1123         sed -f $(REPLACE_VARS_SED) < $< > $@
1124
1125 epydoc.conf: epydoc.conf.in $(REPLACE_VARS_SED)
1126         sed -f $(REPLACE_VARS_SED) < $< > $@
1127
1128 vcs-version:
1129         if test -d .git; then \
1130           git describe > $@; \
1131         elif test ! -f $@ ; then \
1132           echo "Cannot auto-generate $@ file"; exit 1; \
1133         fi
1134
1135 .PHONY: clean-vcs-version
1136 clean-vcs-version:
1137         rm -f vcs-version
1138
1139 .PHONY: regen-vcs-version
1140 regen-vcs-version:
1141         set -e; \
1142         cd $(srcdir); \
1143         if test -d .git; then \
1144           $(MAKE) $(AM_MAKEFLAGS) clean-vcs-version; \
1145           $(MAKE) $(AM_MAKEFLAGS) vcs-version; \
1146         fi
1147
1148 htools/Ganeti/Version.hs: htools/Ganeti/Version.hs.in \
1149         vcs-version $(built_base_sources)
1150         set -e; \
1151         VCSVER=`cat $(abs_top_srcdir)/vcs-version`; \
1152         sed -e "s/%ver%/$$VCSVER/" < $< > $@
1153
1154 htools/Ganeti/Constants.hs: htools/Ganeti/Constants.hs.in \
1155         lib/constants.py lib/_autoconf.py lib/luxi.py \
1156         $(CONVERT_CONSTANTS) $(built_base_sources) \
1157         | lib/_vcsversion.py
1158         set -e; \
1159         { cat $< ; PYTHONPATH=. $(CONVERT_CONSTANTS); } > $@
1160
1161 htest/Test/Ganeti/TestImports.hs: htest/Test/Ganeti/TestImports.hs.in \
1162         $(built_base_sources)
1163         set -e; \
1164         { cat $< ; \
1165           echo ; \
1166           for name in $(filter-out Ganeti.THH,$(subst /,.,$(patsubst %.hs,%,$(patsubst htools/%,%,$(HS_LIB_SRCS))))) ; do \
1167             echo "import $$name ()" ; \
1168           done ; \
1169         } > $@
1170
1171 lib/_autoconf.py: Makefile | stamp-directories
1172         set -e; \
1173         { echo '# This file is automatically generated, do not edit!'; \
1174           echo '#'; \
1175           echo ''; \
1176           echo '"""Build-time configuration for Ganeti.'; \
1177           echo '';\
1178           echo 'This file is autogenerated by the build process.'; \
1179           echo 'For any changes you need to re-run ./configure (and'; \
1180           echo 'not edit by hand).'; \
1181           echo ''; \
1182           echo '"""'; \
1183           echo ''; \
1184           echo '# pylint: disable=C0301,C0324'; \
1185           echo '# because this is autogenerated, we do not want'; \
1186           echo '# style warnings' ; \
1187           echo ''; \
1188           echo "PACKAGE_VERSION = '$(PACKAGE_VERSION)'"; \
1189           echo "VERSION_MAJOR = '$(VERSION_MAJOR)'"; \
1190           echo "VERSION_MINOR = '$(VERSION_MINOR)'"; \
1191           echo "VERSION_REVISION = '$(VERSION_REVISION)'"; \
1192           echo "VERSION_SUFFIX = '$(VERSION_SUFFIX)'"; \
1193           echo "VERSION_FULL = '$(VERSION_FULL)'"; \
1194           echo "LOCALSTATEDIR = '$(localstatedir)'"; \
1195           echo "SYSCONFDIR = '$(sysconfdir)'"; \
1196           echo "SSH_CONFIG_DIR = '$(SSH_CONFIG_DIR)'"; \
1197           echo "SSH_LOGIN_USER = '$(SSH_LOGIN_USER)'"; \
1198           echo "SSH_CONSOLE_USER = '$(SSH_CONSOLE_USER)'"; \
1199           echo "EXPORT_DIR = '$(EXPORT_DIR)'"; \
1200           echo "OS_SEARCH_PATH = [$(OS_SEARCH_PATH)]"; \
1201           echo "XEN_BOOTLOADER = '$(XEN_BOOTLOADER)'"; \
1202           echo "XEN_KERNEL = '$(XEN_KERNEL)'"; \
1203           echo "XEN_INITRD = '$(XEN_INITRD)'"; \
1204           echo "KVM_KERNEL = '$(KVM_KERNEL)'"; \
1205           echo "FILE_STORAGE_DIR = '$(FILE_STORAGE_DIR)'"; \
1206           echo "ENABLE_FILE_STORAGE = $(ENABLE_FILE_STORAGE)"; \
1207           echo "SHARED_FILE_STORAGE_DIR = '$(SHARED_FILE_STORAGE_DIR)'"; \
1208           echo "ENABLE_SHARED_FILE_STORAGE = $(ENABLE_SHARED_FILE_STORAGE)"; \
1209           echo "IALLOCATOR_SEARCH_PATH = [$(IALLOCATOR_SEARCH_PATH)]"; \
1210           echo "KVM_PATH = '$(KVM_PATH)'"; \
1211           echo "IP_PATH = '$(IP_PATH)'"; \
1212           echo "SOCAT_PATH = '$(SOCAT)'"; \
1213           echo "SOCAT_USE_ESCAPE = $(SOCAT_USE_ESCAPE)"; \
1214           echo "SOCAT_USE_COMPRESS = $(SOCAT_USE_COMPRESS)"; \
1215           echo "LVM_STRIPECOUNT = $(LVM_STRIPECOUNT)"; \
1216           echo "TOOLSDIR = '$(toolsdir)'"; \
1217           echo "GNT_SCRIPTS = [$(foreach i,$(notdir $(gnt_scripts)),'$(i)',)]"; \
1218           echo "HTOOLS_PROGS = [$(foreach i,$(HS_HTOOLS_PROGS),'$(i)',)]"; \
1219           echo "PKGLIBDIR = '$(pkglibdir)'"; \
1220           echo "DRBD_BARRIERS = '$(DRBD_BARRIERS)'"; \
1221           echo "DRBD_NO_META_FLUSH = $(DRBD_NO_META_FLUSH)"; \
1222           echo "SYSLOG_USAGE = '$(SYSLOG_USAGE)'"; \
1223           echo "DAEMONS_GROUP = '$(DAEMONS_GROUP)'"; \
1224           echo "ADMIN_GROUP = '$(ADMIN_GROUP)'"; \
1225           echo "MASTERD_USER = '$(MASTERD_USER)'"; \
1226           echo "MASTERD_GROUP = '$(MASTERD_GROUP)'"; \
1227           echo "RAPI_USER = '$(RAPI_USER)'"; \
1228           echo "RAPI_GROUP = '$(RAPI_GROUP)'"; \
1229           echo "CONFD_USER = '$(CONFD_USER)'"; \
1230           echo "CONFD_GROUP = '$(CONFD_GROUP)'"; \
1231           echo "NODED_USER = '$(NODED_USER)'"; \
1232           echo "NODED_GROUP = '$(NODED_GROUP)'"; \
1233           echo "DISK_SEPARATOR = '$(DISK_SEPARATOR)'"; \
1234           echo "QEMUIMG_PATH = '$(QEMUIMG_PATH)'"; \
1235           echo "HTOOLS = True"; \
1236           echo "ENABLE_CONFD = $(ENABLE_CONFD)"; \
1237           echo "XEN_CMD = '$(XEN_CMD)'"; \
1238           echo "ENABLE_SPLIT_QUERY = $(ENABLE_SPLIT_QUERY)"; \
1239         } > $@
1240
1241 lib/_vcsversion.py: Makefile vcs-version | stamp-directories
1242         set -e; \
1243         VCSVER=`cat $(abs_top_srcdir)/vcs-version`; \
1244         { echo '# This file is automatically generated, do not edit!'; \
1245           echo '#'; \
1246           echo ''; \
1247           echo '"""Build-time VCS version number for Ganeti.'; \
1248           echo '';\
1249           echo 'This file is autogenerated by the build process.'; \
1250           echo 'For any changes you need to re-run ./configure (and'; \
1251           echo 'not edit by hand).'; \
1252           echo ''; \
1253           echo '"""'; \
1254           echo ''; \
1255           echo '# pylint: disable=C0301,C0324'; \
1256           echo '# because this is autogenerated, we do not want'; \
1257           echo '# style warnings' ; \
1258           echo ''; \
1259           echo "VCS_VERSION = '$$VCSVER'"; \
1260         } > $@
1261
1262 lib/_generated_rpc.py: lib/rpc_defs.py $(BUILD_RPC)
1263         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(BUILD_RPC) lib/rpc_defs.py > $@
1264
1265 $(SHELL_ENV_INIT): Makefile stamp-directories
1266         set -e; \
1267         { echo '# Allow overriding for tests'; \
1268           echo 'readonly LOCALSTATEDIR=$${LOCALSTATEDIR:-$${GANETI_ROOTDIR:-}$(localstatedir)}'; \
1269           echo 'readonly SYSCONFDIR=$${SYSCONFDIR:-$${GANETI_ROOTDIR:-}$(sysconfdir)}'; \
1270           echo; \
1271           echo 'readonly PKGLIBDIR=$(pkglibdir)'; \
1272           echo 'readonly LOG_DIR="$$LOCALSTATEDIR/log/ganeti"'; \
1273           echo 'readonly RUN_DIR="$$LOCALSTATEDIR/run/ganeti"'; \
1274           echo 'readonly DATA_DIR="$$LOCALSTATEDIR/lib/ganeti"'; \
1275           echo 'readonly CONF_DIR="$$SYSCONFDIR/ganeti"'; \
1276         } > $@
1277
1278 $(REPLACE_VARS_SED): $(SHELL_ENV_INIT) Makefile stamp-directories
1279         set -e; \
1280         { echo 's#@PREFIX@#$(prefix)#g'; \
1281           echo 's#@SYSCONFDIR@#$(sysconfdir)#g'; \
1282           echo 's#@LOCALSTATEDIR@#$(localstatedir)#g'; \
1283           echo 's#@BINDIR@#$(bindir)#g'; \
1284           echo 's#@SBINDIR@#$(sbindir)#g'; \
1285           echo 's#@GANETI_VERSION@#$(PACKAGE_VERSION)#g'; \
1286           echo 's#@CUSTOM_XEN_BOOTLOADER@#$(XEN_BOOTLOADER)#g'; \
1287           echo 's#@CUSTOM_XEN_KERNEL@#$(XEN_KERNEL)#g'; \
1288           echo 's#@CUSTOM_XEN_INITRD@#$(XEN_INITRD)#g'; \
1289           echo 's#@CUSTOM_IALLOCATOR_SEARCH_PATH@#$(IALLOCATOR_SEARCH_PATH)#g'; \
1290           echo 's#@CUSTOM_EXPORT_DIR@#$(EXPORT_DIR)#g'; \
1291           echo 's#@RPL_FILE_STORAGE_DIR@#$(FILE_STORAGE_DIR)#g'; \
1292           echo 's#@RPL_SSH_INITD_SCRIPT@#$(SSH_INITD_SCRIPT)#g'; \
1293           echo 's#@PKGLIBDIR@#$(pkglibdir)#g'; \
1294           echo 's#@GNTMASTERUSER@#$(MASTERD_USER)#g'; \
1295           echo 's#@GNTRAPIUSER@#$(RAPI_USER)#g'; \
1296           echo 's#@GNTCONFDUSER@#$(CONFD_USER)#g'; \
1297           echo 's#@GNTNODEDUSER@#$(NODED_USER)#g'; \
1298           echo 's#@GNTRAPIGROUP@#$(RAPI_GROUP)#g'; \
1299           echo 's#@GNTADMINGROUP@#$(ADMIN_GROUP)#g'; \
1300           echo 's#@GNTCONFDGROUP@#$(CONFD_GROUP)#g'; \
1301           echo 's#@GNTMASTERDGROUP@#$(MASTERD_GROUP)#g'; \
1302           echo 's#@GNTDAEMONSGROUP@#$(DAEMONS_GROUP)#g'; \
1303           echo 's#@CUSTOM_ENABLE_CONFD@#$(ENABLE_CONFD)#g'; \
1304           echo 's#@MODULES@#$(strip $(lint_python_code))#g'; \
1305           echo 's#@ENABLE_SPLIT_QUERY@#$(ENABLE_SPLIT_QUERY)#g'; \
1306           echo; \
1307           echo '/^@SHELL_ENV_INIT@$$/ {'; \
1308           echo '  r $(SHELL_ENV_INIT)'; \
1309           echo '  d'; \
1310           echo '}'; \
1311         } > $@
1312
1313 # Using deferred evaluation
1314 daemons/ganeti-%: MODULE = ganeti.server.$(patsubst ganeti-%,%,$(notdir $@))
1315 daemons/ganeti-watcher: MODULE = ganeti.watcher
1316 scripts/%: MODULE = ganeti.client.$(subst -,_,$(notdir $@))
1317 tools/ensure-dirs: MODULE = ganeti.tools.ensure_dirs
1318 $(HS_BUILT_TEST_HELPERS): TESTROLE = $(patsubst htest/%,%,$@)
1319
1320 $(PYTHON_BOOTSTRAP): Makefile | stamp-directories
1321         test -n "$(MODULE)" || { echo Missing module; exit 1; }
1322         set -e; \
1323         { echo '#!/usr/bin/python'; \
1324           echo '# This file is automatically generated, do not edit!'; \
1325           echo "# Edit $(MODULE) instead."; \
1326           echo; \
1327           echo '"""Bootstrap script for L{$(MODULE)}"""'; \
1328           echo; \
1329           echo '# pylint: disable=C0103'; \
1330           echo '# C0103: Invalid name'; \
1331           echo; \
1332           echo 'import sys'; \
1333           echo 'import $(MODULE) as main'; \
1334           echo; \
1335           echo '# Temporarily alias commands until bash completion'; \
1336           echo '# generator is changed'; \
1337           echo 'if hasattr(main, "commands"):'; \
1338           echo '  commands = main.commands # pylint: disable=E1101'; \
1339           echo 'if hasattr(main, "aliases"):'; \
1340           echo '  aliases = main.aliases # pylint: disable=E1101'; \
1341           echo; \
1342           echo 'if __name__ == "__main__":'; \
1343           echo '  sys.exit(main.Main())'; \
1344         } > $@
1345         chmod u+x $@
1346
1347 $(HS_BUILT_TEST_HELPERS): Makefile
1348         @test -n "$(TESTROLE)" || { echo Missing TESTROLE; exit 1; }
1349         set -e; \
1350         { echo '#!/bin/sh'; \
1351           echo '# This file is automatically generated, do not edit!'; \
1352           echo "# Edit Makefile.am instead."; \
1353           echo; \
1354           echo "HTOOLS=$(TESTROLE) exec ./htest/hpc-htools \"\$$@\""; \
1355         } > $@
1356         chmod u+x $@
1357
1358 stamp-directories: Makefile
1359         $(MAKE) $(AM_MAKEFLAGS) ganeti
1360         @mkdir_p@ $(DIRS) $(BUILDTIME_DIR_AUTOCREATE)
1361         touch $@
1362
1363 # We need to create symlinks because "make distcheck" will not install Python
1364 # files when building.
1365 stamp-srclinks: Makefile | stamp-directories
1366         set -e; \
1367         for i in $(srclink_files); do \
1368                 if test ! -f $$i -a -f $(abs_top_srcdir)/$$i; then \
1369                         $(LN_S) $(abs_top_srcdir)/$$i $$i; \
1370                 fi; \
1371         done
1372         touch $@
1373
1374 .PHONY: ganeti
1375 ganeti:
1376         cd $(top_builddir) && test -h "$@" || { rm -f $@ && $(LN_S) lib $@; }
1377
1378 .PHONY: check-dirs
1379 check-dirs: $(GENERATED_FILES)
1380         @set -e; \
1381         find . -type d \( \( -name . \) -o \( \
1382                 -name .git -o \
1383                 -name autom4te.cache \
1384                 \) -prune -o -print \) | { \
1385                 error=; \
1386                 while read dir; do \
1387                         case "$$dir" in \
1388                                 $(strip $(patsubst %,(./%) ;;,$(DIRCHECK_EXCLUDE) $(DIRS))) \
1389                                 *) error=1; echo "Directory $$dir not listed in Makefile" >&2 ;; \
1390                         esac; \
1391                 done; \
1392                 for dir in $(DIRS); do \
1393                         if ! test -d "$$dir"; then \
1394                                 echo "Directory $$dir listed in DIRS does not exist" >&2; \
1395                                 error=1; \
1396                         fi \
1397                 done; \
1398                 if test -n "$$error"; then exit 1; else exit 0; fi; \
1399         }
1400
1401 .PHONY: check-local
1402 check-local: check-dirs $(GENERATED_FILES)
1403         $(CHECK_PYTHON_CODE) $(check_python_code)
1404         PYTHONPATH=. $(CHECK_HEADER) $(check_python_code)
1405         $(CHECK_VERSION) $(VERSION) $(top_srcdir)/NEWS
1406         $(CHECK_NEWS) < $(top_srcdir)/NEWS
1407         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(CHECK_IMPORTS) . $(standalone_python_modules)
1408         @expver=$(VERSION_MAJOR).$(VERSION_MINOR); \
1409         if test "`head -n 1 $(top_srcdir)/README`" != "Ganeti $$expver"; then \
1410                 echo "Incorrect version in README, expected $$expver"; \
1411                 exit 1; \
1412         fi; \
1413         for file in doc/iallocator.rst doc/hooks.rst doc/virtual-cluster.rst; do \
1414                 if test "`sed -ne '4 p' $(top_srcdir)/$$file`" != \
1415                         "Documents Ganeti version $$expver"; then \
1416                         echo "Incorrect version in $$file, expected $$expver"; \
1417                         exit 1; \
1418                 fi; \
1419         done
1420
1421 .PHONY: hs-check
1422 hs-check: htest/test htest/hpc-htools $(HS_BUILT_TEST_HELPERS)
1423         @rm -f test.tix
1424         ./htest/test
1425         HBINARY="./htest/hpc-htools" ./htest/offline-test.sh
1426
1427 # E111: indentation is not a multiple of four
1428 # E121: continuation line indentation is not a multiple of four
1429 #       (since our indent level is not 4)
1430 # E125: continuation line does not distinguish itself from next logical line
1431 #       (since our indent level is not 4)
1432 # E127: continuation line over-indented for visual indent
1433 #       (since our indent level is not 4)
1434 # note: do NOT add E128 here; it's a valid style error in most cases!
1435 # I've seen real errors, but also some cases were we indent wrongly
1436 # due to line length; try to rework the cases where it is triggered,
1437 # instead of silencing it
1438 # E261: at least two spaces before inline comment
1439 # E501: line too long (80 characters)
1440 PEP8_IGNORE = E111,E121,E125,E127,E261,E501
1441
1442 # For excluding pep8 expects filenames only, not whole paths
1443 PEP8_EXCLUDE = $(subst $(space),$(comma),$(strip $(notdir $(BUILT_PYTHON_SOURCES))))
1444
1445 LINT_TARGETS = pylint pylint-qa
1446 if HAS_PEP8
1447 LINT_TARGETS += pep8
1448 endif
1449 if HAS_HLINT
1450 LINT_TARGETS += hlint
1451 endif
1452
1453 .PHONY: lint
1454 lint: $(LINT_TARGETS)
1455
1456 .PHONY: pylint
1457 pylint: $(GENERATED_FILES)
1458         @test -n "$(PYLINT)" || { echo 'pylint' not found during configure; exit 1; }
1459         $(PYLINT) $(LINT_OPTS) $(lint_python_code)
1460
1461 .PHONY: pylint-qa
1462 pylint-qa: $(GENERATED_FILES)
1463         @test -n "$(PYLINT)" || { echo 'pylint' not found during configure; exit 1; }
1464         cd $(top_srcdir)/qa && \
1465           PYTHONPATH=$(abs_top_srcdir) $(PYLINT) $(LINT_OPTS) \
1466           --rcfile  ../pylintrc $(patsubst qa/%.py,%,$(qa_scripts))
1467
1468 .PHONY: pep8
1469 pep8: $(GENERATED_FILES)
1470         @test -n "$(PEP8)" || { echo 'pep8' not found during configure; exit 1; }
1471         $(PEP8) --ignore='$(PEP8_IGNORE)' --exclude='$(PEP8_EXCLUDE)' \
1472                 --repeat $(pep8_python_code)
1473
1474 # FIXME: remove ignore "Use void" when GHC 6.x is deprecated
1475 .PHONY: hlint
1476 hlint: $(HS_BUILT_SRCS) htools/lint-hints.hs
1477         @test -n "$(HLINT)" || { echo 'hlint' not found during configure; exit 1; }
1478         if tty -s; then C="-c"; else C=""; fi; \
1479         $(HLINT) --report=doc/hs-lint.html --cross $$C \
1480           --ignore "Use first" \
1481           --ignore "Use comparing" \
1482           --ignore "Use on" \
1483           --ignore "Reduce duplication" \
1484           --ignore "Use &&&" \
1485           --ignore "Use void" \
1486           --hint htools/lint-hints \
1487           $(filter-out htools/Ganeti/THH.hs,$(HS_LIBTEST_SRCS))
1488
1489 # a dist hook rule for updating the vcs-version file; this is
1490 # hardcoded due to where it needs to build the file...
1491 dist-hook:
1492         $(MAKE) $(AM_MAKEFLAGS) regen-vcs-version
1493         rm -f $(top_distdir)/vcs-version
1494         cp -p $(srcdir)/vcs-version $(top_distdir)
1495
1496 # a distcheck hook rule for catching revision control directories
1497 distcheck-hook:
1498         if find $(top_distdir) -name .svn -or -name .git | grep .; then \
1499                 echo "Found revision control files in final archive." 1>&2; \
1500                 exit 1; \
1501         fi
1502         if find $(top_distdir) -name '*.py[co]' | grep .; then \
1503                 echo "Found Python byte code in final archive." 1>&2; \
1504                 exit 1; \
1505         fi
1506         if find $(top_distdir) -name '*~' | grep .; then \
1507                 echo "Found backup files in final archive." 1>&2; \
1508                 exit 1; \
1509         fi
1510 # Empty files or directories should not be distributed. They can cause
1511 # unnecessary warnings for packagers. Directories used by automake during
1512 # distcheck must be excluded.
1513         if find $(top_distdir) -empty -and -not \( \
1514                         -path $(top_distdir)/_build -or \
1515                         -path $(top_distdir)/_inst \) | grep .; then \
1516                 echo "Found empty files or directories in final archive." 1>&2; \
1517                 exit 1; \
1518         fi
1519         if test -n "$(BUILD_RELEASE)" && \
1520            grep -n -H -E '^\*.*unreleased' $(top_distdir)/NEWS; then \
1521                 echo "Found unreleased version in NEWS." >&2; \
1522                 exit 1; \
1523         fi
1524
1525 # When building a release, stricter checks should be used
1526 distcheck-release dist-release: export BUILD_RELEASE = 1
1527 distcheck-release: distcheck
1528
1529 distrebuildcheck: dist
1530         set -e; \
1531         builddir=$$(mktemp -d $(abs_srcdir)/distrebuildcheck.XXXXXXX); \
1532         trap "echo Removing $$builddir; cd $(abs_srcdir); rm -rf $$builddir" EXIT; \
1533         cd $$builddir; \
1534         tar xzf $(abs_srcdir)/$(distdir).tar.gz; \
1535         cd $(distdir); \
1536         ./configure; \
1537         $(MAKE) maintainer-clean; \
1538         cp $(abs_srcdir)/vcs-version .; \
1539         ./configure; \
1540         $(MAKE) $(AM_MAKEFLAGS)
1541
1542 dist-release: dist
1543         set -e; \
1544         for i in $(DIST_ARCHIVES); do \
1545                 echo -n "Checking $$i ... "; \
1546                 autotools/check-tar < $$i; \
1547                 echo OK; \
1548         done
1549
1550 install-exec-local:
1551         @mkdir_p@ "$(DESTDIR)${localstatedir}/lib/ganeti" \
1552           "$(DESTDIR)${localstatedir}/log/ganeti" \
1553           "$(DESTDIR)${localstatedir}/run/ganeti"
1554
1555 .PHONY: apidoc
1556 if WANT_HTOOLSAPIDOC
1557 apidoc: py-apidoc hs-apidoc
1558 else
1559 apidoc: py-apidoc
1560 endif
1561
1562 .PHONY: py-apidoc
1563 py-apidoc: epydoc.conf $(RUN_IN_TEMPDIR) $(GENERATED_FILES)
1564         $(RUN_IN_TEMPDIR) epydoc -v \
1565                 --conf $(CURDIR)/epydoc.conf \
1566                 --output $(CURDIR)/$(APIDOC_PY_DIR)
1567
1568 .PHONY: hs-apidoc
1569 hs-apidoc: $(HS_BUILT_SRCS)
1570         @test -n "$(HSCOLOUR)" || \
1571             { echo 'HsColour' not found during configure; exit 1; }
1572         @test -n "$(HADDOCK)" || \
1573             { echo 'haddock' not found during configure; exit 1; }
1574         rm -rf $(APIDOC_HS_DIR)/*
1575         @mkdir_p@ $(APIDOC_HS_DIR)/Ganeti/HTools/Program
1576         @mkdir_p@ $(APIDOC_HS_DIR)/Ganeti/Confd
1577         @mkdir_p@ $(APIDOC_HS_DIR)/Ganeti/Query
1578         $(HSCOLOUR) -print-css > $(APIDOC_HS_DIR)/Ganeti/hscolour.css
1579         $(LN_S) ../hscolour.css $(APIDOC_HS_DIR)/Ganeti/HTools/hscolour.css
1580         $(LN_S) ../hscolour.css $(APIDOC_HS_DIR)/Ganeti/Confd/hscolour.css
1581         set -e ; \
1582         cd htools; \
1583         if [ "$(HTOOLS_NOCURL)" ]; \
1584         then OPTGHC="--optghc=$(HTOOLS_NOCURL)"; \
1585         else OPTGHC=""; \
1586         fi; \
1587         if [ "$(HTOOLS_PARALLEL3)" ]; \
1588         then OPTGHC="$$OPTGHC --optghc=$(HTOOLS_PARALLEL3)"; \
1589         fi; \
1590         if [ "$(HTOOLS_REGEX_PCRE)" ]; \
1591         then OPTGHC="$$OPTGHC --optghc=$(HTOOLS_REGEX_PCRE)"; \
1592         fi; \
1593         RELSRCS="$(HS_LIB_SRCS:htools/%=%) $(patsubst htools/%,%,$(filter htools/%,$(HS_BUILT_SRCS)))"; \
1594         for file in $$RELSRCS; do \
1595                 hfile=`echo $$file|sed 's/\\.hs$$//'`.html; \
1596                 $(HSCOLOUR) -css -anchor $$file > ../$(APIDOC_HS_DIR)/$$hfile ; \
1597         done ; \
1598         $(HADDOCK) --odir ../$(APIDOC_HS_DIR) --html --ignore-all-exports -w \
1599                 -t ganeti-htools -p haddock-prologue \
1600                 --source-module="%{MODULE/.//}.html" \
1601                 --source-entity="%{MODULE/.//}.html#%{NAME}" \
1602                 $$OPTGHC \
1603                 $(filter-out Ganeti/HTools/ExtLoader.hs,$(HS_LIB_SRCS:htools/%=%))
1604
1605 .PHONY: TAGS
1606 TAGS: $(GENERATED_FILES)
1607         rm -f TAGS
1608         $(GHC) -e ":etags" -v0 \
1609           $(filter-out -O -Werror,$(HFLAGS)) \
1610           $(HTOOLS_NOCURL) $(HTOOLS_PARALLEL3) $(HTOOLS_REGEX_PCRE) \
1611           $(HS_LIBTEST_SRCS)
1612         find . -path './lib/*.py' -o -path './scripts/gnt-*' -o \
1613           -path './daemons/ganeti-*' -o -path './tools/*' -o \
1614           -path './qa/*.py' | \
1615           etags -l python -a -
1616
1617 .PHONY: coverage
1618 if WANT_HTOOLS
1619 coverage: py-coverage hs-coverage
1620 else
1621 coverage: py-coverage
1622 endif
1623
1624 .PHONY: py-coverage
1625 py-coverage: $(GENERATED_FILES) $(python_tests)
1626         set -e; \
1627         COVERAGE_FILE=$(CURDIR)/$(COVERAGE_PY_DIR)/data \
1628         TEXT_COVERAGE=$(CURDIR)/$(COVERAGE_PY_DIR)/report.txt \
1629         HTML_COVERAGE=$(CURDIR)/$(COVERAGE_PY_DIR) \
1630         $(PLAIN_TESTS_ENVIRONMENT) $(abs_top_srcdir)/autotools/gen-coverage \
1631         $(python_tests)
1632
1633 .PHONY: hs-coverage
1634 hs-coverage: $(haskell_tests) htest/hpc-htools
1635         rm -f *.tix
1636         $(MAKE) $(AM_MAKEFLAGS) hs-check
1637         @mkdir_p@ $(COVERAGE_HS_DIR)
1638         hpc combine --union $(HPCEXCL) \
1639           test.tix hpc-htools.tix > coverage-htools.tix
1640         hpc markup --destdir=$(COVERAGE_HS_DIR) coverage-htools.tix
1641         hpc report coverage-htools.tix
1642         $(LN_S) -f hpc_index.html $(COVERAGE_HS_DIR)/index.html
1643
1644 # Special "kind-of-QA" target for htools, needs special setup (all
1645 # tools compiled with -fhpc)
1646 .PHONY: live-test
1647 live-test: all
1648         set -e ; \
1649         cd htools; \
1650         rm -f .hpc; $(LN_S) ../.hpc .hpc; \
1651         rm -f *.tix *.mix; \
1652         ./live-test.sh; \
1653         hpc sum --union $(HPCEXCL) $(addsuffix .tix,$(HS_PROGS:htools/%=%)) \
1654           --output=live-test.tix ; \
1655         @mkdir_p@ ../$(COVERAGE_HS_DIR) ; \
1656         hpc markup --destdir=../$(COVERAGE_HS_DIR) live-test \
1657                 --srcdir=.. $(HPCEXCL) ; \
1658         hpc report --srcdir=.. live-test $(HPCEXCL)
1659
1660 commit-check: distcheck lint apidoc
1661
1662 .PHONY: gitignore-check
1663 gitignore-check:
1664         @if [ -n "`git status --short`" ]; then \
1665           echo "Git status is not clean!" 1>&2 ; \
1666           git status --short; \
1667           exit 1; \
1668         fi
1669
1670 # we don't need the ancient implicit rules:
1671 %: %,v
1672 %: RCS/%,v
1673 %: RCS/%
1674 %: s.%
1675 %: SCCS/s.%
1676
1677 -include ./Makefile.local
1678
1679 # vim: set noet :